;  5\cr_tb.lsp
;  .., 2006 .
;  : .., ..
;"AutoLISP  Visual LISP   AutoCAD"
; ( "-", 2006)
;
;  5.1.  cr_tb.lsp
;

(defun cr_tb (g_name t_name l_names l_helps l_macros
  l_icons cx cy nrows / wbOK mgs mg tbs tb i tbitem)
(vl-load-com)
(setq mgs (vla-get-MenuGroups (vlax-get-acad-object)))
(if (= (type g_name) 'STR)
  (setq wbOK (if mgs T nil)))
(if wbOK
  (progn
;   : Automation Error. Invalid argument XXX in Item
    (setq mg (vl-catch-all-apply 'vla-Item (list mgs g_name)))
    (if (/= (type mg) 'VLA-OBJECT)
      (progn
	(setq wbOK nil)
        (princ "\n    (). ")
      );progn
    );if
  );progn
);if

;   
; ,     
(if wbOK
  (progn
    (if (= (type t_name) 'STR)
      (progn
        (setq tbs (vla-get-Toolbars mg))
	;   : Automation Error. Invalid argument XXX in Item
        (setq tb (vl-catch-all-apply 'vla-Item (list tbs t_name)))
        (if (not (vl-catch-all-error-p tb))
	  (progn
	    (setq wbOK nil);  
            (princ "\n  . ")
	  );progn
        );if
      );progn
      (progn
	(setq wbOK nil)
        (princ "\n  . ")
      );progn
    );if
  );progn
);if

;    .   
(if wbOK
  (progn
    (setq tb (vla-Add tbs t_name))
    (if tb
      (progn
    ;     
    ;     -
	(setq i -1)
	(repeat (length l_names)
	  (setq i (1+ i))
          (setq tbitem (vla-AddToolbarButton tb
     i (nth i l_names) (nth i l_helps) (nth i l_macros)));  i
	  (vla-SetBitmaps tbitem (nth i l_icons) (nth i l_icons))
	);repeat
	;       
	(vla-Float tb cx cy nrows)
        (princ (strcat "\n " t_name
          "    " g_name ". "))
	(setq g_tb tb);    
                      ;   
        (vlr-beep-reaction);  
      );progn
      (princ (strcat "\n   " t_name
        "     " g_name ". "))
    );if
  );progn
);if
;  ,   VLA-
(mapcar (function (lambda (x)
  (if (and x (not (vlax-object-released-p x)))
    (vlax-release-object x)))) (list mgs mg tbs tbitem))
(princ)
);defun cr_tb

